#!/usr/bin/python

#/* Copyright (C) 2007 P.L. Lucas
 #*
 #* This program is free software; you can redistribute it and/or modify
 #* it under the terms of the GNU General Public License as published by
 #* the Free Software Foundation; either version 2 of the License, or
 #* (at your option) any later version.
 #*
 #* This program is distributed in the hope that it will be useful,
 #* but WITHOUT ANY WARRANTY; without even the implied warranty of
 #* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #* GNU General Public License for more details.
 #*
 #* You should have received a copy of the GNU General Public License
 #* along with this program; if not, write to the Free Software
 #* Foundation, Inc., 59 Temple Place, Suite 330, 
 #* Boston, MA 02111-1307, USA. 
 #*/

import sys
import xml.sax
import xml.sax.handler
import xml.sax.xmlreader
import gtk
import pango
import threading
import gobject
import select
import time
import os
import string

####################################################################

windows_opened=0

def window_destroy(windows_opened=windows_opened):
	windows_opened=windows_opened-1

def destroy(window,*data):
	window.hide()
	window_destroy()
	if windows_opened==0:
		print "No quedan ventanas"
		sys.stdout.flush()
		sys.stdout.close()
		sys.stdin.close()
		sys.stderr.close()
		gtk.main_quit()
		os._exit(0)

def window_create(windows_opened=windows_opened):
	windows_opened=windows_opened+1

####################################################################

class Widget:
	def __init__(self):
		self.container=False
		self.widget=""
		self.name=""
		self.output=None
		self.expand=False
	def startElement(self, name, attrs):
		"""Process xmlHandler.
			return True si se consume el token
		"""
	
	def endElement(self, name, text):
		"""Process xmlHandler
			return True si es el fin del objeto
		"""
	
	def add_widget(self, widget):
		"""Add widget."""
	
	def checkId(self, attrs):
		_id=attrs.getValue("id")
		if self.name == _id:
			return True
		else:
			return False
	
	def properties(self, attrs):
		if attrs.has_key("expand"):
			value=attrs.getValue("expand")
			if value=="true":
				self.expand=True
			else:
				self.expand=False
		if attrs.has_key("bold"):
			value=attrs.getValue("bold")
			if value=="true":
				#style=self.widget.rc_get_style()
				stylerc=self.widget.get_modifier_style()
				self.widget.modify_style(stylerc)
				#font=style.font_desc.copy()
				font=pango.FontDescription("Times, 24")
				font.set_weight(pango.WEIGHT_BOLD)
				font.set_size(32)
				font.set_style(pango.STYLE_ITALIC)
				self.widget.modify_font(font)




####################################################################

class Window(Widget):
	def __init__(self):
		self.container=True
		self.expand=False
		self.widget=gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.vbox=gtk.VBox(False)
		self.widget.add(self.vbox)
		self.window_maximized=False
		self.name=""
		self.widget.connect("destroy", destroy)
		window_create()
		

	def startElement(self,name, attrs):
		if name=="window":
			if self.checkId(attrs):
				self.properties(attrs)
				if attrs.has_key("title"):
					title=attrs.getValue("title")
					self.widget.set_title(title)
				if attrs.has_key("maximize"):
					value=attrs.getValue("maximize")
					if value=="true":
						self.window_maximized=True
					else:
						self.window_maximized=False
				if attrs.has_key("minimize"):
					value=attrs.getValue("minimize")
					if value=="true":
						self.widget.iconify()
					else:
						self.widget.deiconify()
				return True
		return False
	
	def endElement(self, name, text):
		if name=="window":
			if self.window_maximized==True:
				self.widget.maximize()
			else:
				self.widget.unmaximize()
			self.widget.show_all()
			return True
	
	def add_widget(self, widget):
		self.vbox.pack_start(widget.widget,widget.expand,widget.expand,2)



####################################################################

class Button(Widget):
	def __init__(self):
		self.container=False
		self.widget=gtk.Button()
		self.name=""
		self.expand=False
		self.label=None
		self.hbox=gtk.HBox(False, 0)
		self.hbox.show()
		self.icon=gtk.Image()
		self.hbox.pack_start(self.icon,False)
		self.icon.show()
		self.widget.add(self.hbox)

	def startElement(self,name, attrs):
		if name=="button":
			if self.checkId(attrs):
				self.properties(attrs)
				return True
		if name=="signal":
			if attrs.has_key("name"):
				value=attrs.getValue("name")
				if value=="clicked":
					self.widget.connect("clicked", self.clicked_callback)
					return True
		return False
	
	def endElement(self, name, text):
		if name=="button":
			self.widget.show_all()
			return True
		elif name=="text":
			if self.label==None:
				self.label=gtk.Label()
				self.hbox.pack_start(self.label,False)
				self.label.show()
			self.label.set_text(text)
			return False
		elif name=="icon":
			self.icon.set_from_file(text)
			
		return False
	
	def clicked_callback(self,data):
		self.output.write("<button id=\""+self.name+"\" signal=\"clicked\"/>\n")
		self.output.flush()


####################################################################


class VBox(Widget):
	def __init__(self):
		self.container=True
		self.expand=False
		self.widget=gtk.VBox(False)
		self.name=""
		

	def startElement(self,name, attrs):
		if name=="vbox":
			if self.checkId(attrs):
				self.properties(attrs)
				return True
		return False
	
	def endElement(self, name, text):
		if name=="vbox":
			self.widget.show_all()
			return True
	
	def add_widget(self, widget):
		self.widget.pack_start(widget.widget,widget.expand,widget.expand,2)


####################################################################


class HBox(Widget):
	def __init__(self):
		self.container=True
		self.expand=False
		self.widget=gtk.HBox(False)
		self.name=""
		

	def startElement(self,name, attrs):
		if name=="hbox":
			if self.checkId(attrs):
				self.properties(attrs)
				return True
		return False
	
	def endElement(self, name, text):
		if name=="hbox":
			self.widget.show_all()
			return True
	
	def add_widget(self, widget):
		self.widget.pack_start(widget.widget,widget.expand,widget.expand,2)


####################################################################

class Label(Widget):
	def __init__(self):
		self.container=False
		self.widget=gtk.Label()
		self.name=""
		self.expand=False


	def startElement(self,name, attrs):
		if name=="label":
			if self.checkId(attrs):
				self.properties(attrs)
				return True
		if name=="text":
				return True
		return False
	
	def endElement(self, name, text):
		if name=="label":
			self.widget.show_all()
			return True
		elif name=="text":
			self.widget.set_text(text)
			return False
		return False


####################################################################

class LineEdit(Widget):
	def __init__(self):
		self.container=False
		self.widget=gtk.Entry()
		self.name=""
		self.expand=False


	def startElement(self,name, attrs):
		if name=="lineedit":
			if self.checkId(attrs):
				self.properties(attrs)
				return True
		if name=="text":
				return True
		elif name=="get_text":
				return True
		
		return False
	
	def endElement(self, name, text):
		if name=="lineedit":
			self.widget.show_all()
			return True
		elif name=="text":
			self.widget.set_text(text)
			return False
		elif name=="get_text":
			text=self.widget.get_text()
			text=string.replace(text,"<","&lt;")
			text=string.replace(text,">","&gt;")
			self.output.write("<lineedit id=\""+self.name+">\n<text>"+text+"</text>\n</lineedit>\n")
			self.output.flush()
			return False
		return False



####################################################################


class Tree(Widget):
	def __init__(self):
		self.container=False
		self.widget=gtk.ScrolledWindow()
		self.widget.set_shadow_type(gtk.SHADOW_ETCHED_IN)
       		self.widget.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		self.tree=gtk.TreeView()
		self.widget.add(self.tree)
		self.name=""
		self.expand=False
		self.item_stack=[]
		self.item=None
		self.items={}
		self.store=None
		self.headers=[]
		self.col_count=0
		self.render=None


	def startElement(self,name, attrs):
		if name=="tree":
			if self.checkId(attrs):
				self.properties(attrs)
				return True
		elif name=="header":
			if attrs.has_key("name"):
				value=attrs.getValue("name")
				self.headers.append(value)
		elif name=="item":
			if self.store==None:
				#Hay que crear un nuevo TreeStore
				i=len(self.headers)
				types="gobject.TYPE_STRING"
				while i>0:
					types+=",gobject.TYPE_STRING"
					i -= 1
				self.store=eval("gtk.TreeStore("+types+")")
				self.tree.set_model(self.store)
				self.render=gtk.CellRendererText()
				i=0
				while i<len(self.headers):
					column=gtk.TreeViewColumn(self.headers[i],self.render,text=i)
					column.set_resizable(True)
					self.tree.append_column(column)
					i += 1
			self.item_stack.append(self.item)
			
			if attrs.has_key("id"):
				value=attrs.getValue("id")
				if self.items.has_key(value):
					self.item=self.items[value]
				else:
					self.item=self.store.append(self.item)
					self.items[value]=self.item
					self.store.set_value(self.item,len(self.headers),value)
			else:
				self.item=self.store.append(self.item)
			self.col_count=0
			return True
		elif name=="col":
			if attrs.has_key("value"):
				value=attrs.getValue("value")
				self.store.set_value(self.item,self.col_count,value)
				self.col_count+=1
			return True
		elif name=="get_item":
			if attrs.has_key("id"):
				value=attrs.getValue("id")
				if self.items.has_key(value):
					item=self.items[value]
					self.output.write("<tree id=\""+self.name+"\">\n")
					item_id=self.store.get(item,len(self.headers))[0]
					self.output.write("<item id=\""+item_id+"\">\n")
					i=0
					while i<len(self.headers):
						self.output.write("<col value=\""+self.store.get_value(item,i)+"\"/>\n")
						i+=1
					self.output.write("</item>\n</tree>\n")
					self.output.flush()
			return True
		elif name=="signal":
			if attrs.has_key("name"):
				value=attrs.getValue("name")
				if value=="rowclicked":
					self.tree.connect("row-activated", self.clicked_callback)
					return True
		return False
	
	def endElement(self, name, text):
		if name=="tree":
			self.tree.show_all()
			return True
		elif name=="item":
			if len(self.item_stack)>0:
				self.item=self.item_stack.pop()
			else:
				self.item=None
			return False
		elif name=="col":
			return False
		return False
			
	def clicked_callback(self,tree, path, view_column):
		item=self.store.get_iter(path)
		self.output.write("<tree id=\""+self.name+"\">\n")
		item_id=self.store.get(item,len(self.headers))[0]
		self.output.write("<item id=\""+item_id+"\">\n")
		i=0
		while i<len(self.headers):
			self.output.write("<col value=\""+self.store.get_value(item,i)+"\"/>\n")
			i+=1
		self.output.write("</tree>\n")
		self.output.flush()
		return False


####################################################################

class Handler(xml.sax.handler.ContentHandler):
	def __init__(self):
		self.widget_stack=[]
		self.widgets={}
		self.currentText=""

	def startElement(self, name, attrs):
		if name=="widgetserver":
			return
		elif name=="quit":
			gtk.main_quit()
			os._exit(0)
		if len(self.widget_stack)>0:
			w = self.widget_stack[len(self.widget_stack)-1]
			ok=w.startElement(name,attrs)
			if ok==False and w.container:
				w = self.new_widget(name,attrs)
				w.startElement(name,attrs)
				if len(self.widget_stack)>0:
					parent=self.widget_stack[len(self.widget_stack)-1]
					parent.add_widget(w)
				self.widget_stack.append(w)
		else:
			w = self.new_widget(name,attrs)
			w.startElement(name,attrs)
			self.widget_stack.append(w)
		self.currentText=""
	
	def endElement(self, name):
		if name=="widgetserver":
			return
		w = self.widget_stack[len(self.widget_stack)-1]
		ok=w.endElement(name, self.currentText)
		if ok:
			#print "Se saca el widget "+w.name
			self.widget_stack.pop()
			
	
	def characters(self, text):
		self.currentText+=text
	
	def new_widget(self, name, attrs):
		_id=""
		w=None
		if attrs.has_key("id"):
			_id=attrs.getValue("id")
		else:
			print "Error: "+name+" must contains id"
		if self.widgets.has_key(_id):
			w=self.widgets[_id]
			return w
		elif name=="window":
			w = Window()
		elif name=="button":
			w = Button()
		elif name=="vbox":
			w = VBox()
		elif name=="hbox":
			w = HBox()
		elif name=="label":
			w = Label()
		elif name=="lineedit":
			w = LineEdit()
		elif name=="tree":
			w = Tree()
		
		
		#print "Nuevo widget "+_id
		
		w.name=_id
		self.widgets[_id]=w
		w.output=self.output
		
		return w

####################################################################

def callback(id, condition, parser):
		time.sleep(0.5)
		parser.mutex.acquire()
		empty=len(parser.char)
		parser.mutex.release()
		while empty>0:
			parser.mutex.acquire()
			parser.xmlparser.feed(parser.char.pop(0))
			empty=len(parser.char)
			parser.mutex.release()
		return True

class Parser(threading.Thread):
	infd=None
	outfd=None
	xmlparser=None
	def init(self):
		self.infd=sys.stdin;
		self.outfd=sys.stdout;
		gobject.io_add_watch(self.infd,gobject.IO_IN, callback, self);
		
		handler=Handler()
		handler.output=self.outfd
		inputsc=xml.sax.xmlreader.InputSource()
		#inputsc.setByteStream(infd)
		
		self.xmlparser=xml.sax.make_parser(["xml.sax.xmlreader.IncrementalParser"])
		#xmlparser=xml.sax.xmlreader.IncrementalParser()
		self.xmlparser.setContentHandler(handler)
		#xmlparser.parse(inputsc)
		
		self.mutex=threading.Lock()
		self.char=[]
	
	def run(self):
		ch=self.infd.read(1)
		while ch:
			self.mutex.acquire()
			self.char.append(ch)
			self.mutex.release()
			ch=self.infd.read(1)
			#print ch




####################################################################

parser = Parser()
parser.init()
parser.start()

gtk.main()

